Index: LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/aeropt_2bands.F90	(revision 2641)
@@ -12,5 +12,4 @@
   USE phys_local_var_mod, only: absvisaer
   USE pres2lev_mod
-
 
   !    Yves Balkanski le 12 avril 2006
@@ -128,11 +127,7 @@
   REAL :: zrho
   REAL :: fac
-  REAL :: zdp1(klon,klev) 
-  REAL, PARAMETER ::  gravit = 9.80616    ! m2/s
+  REAL :: zdh(klon,klev) 
   INTEGER, ALLOCATABLE, DIMENSION(:)   :: aerosol_name
   INTEGER :: nb_aer
-  REAL, DIMENSION(klon,klev,naero_tot) :: mass_temp
-!RAF
-  REAL, DIMENSION(klon,klev,naero_tot) :: mass_temp_pi
 
   !
@@ -587,11 +582,8 @@
   END IF ! firstcall
 
-
   DO k=1, klev
     DO i=1, klon
-      zrho=pplay(i,k)/t_seri(i,k)/RD                  ! kg/m3
-      mass_temp(i,k,:) = m_allaer(i,k,:) / zrho / 1.e+9
-      mass_temp_pi(i,k,:) = m_allaer_pi(i,k,:) / zrho / 1.e+9
-      zdp1(i,k)=pdel(i,k)/(gravit*delt)      ! air mass auxiliary  variable --> zdp1 [kg/(m^2 *s)]
+      zrho=pplay(i,k)/t_seri(i,k)/RD    ! kg/m3
+      zdh(i,k)=pdel(i,k)/(RG*zrho)      ! m
     ENDDO
   ENDDO
@@ -645,6 +637,4 @@
   !      compute optical_thickness_at_gridpoint_per_species
 
-
-
 !CDIR ON_ADB(fact_RH)
 !CDIR SHORTLOOP
@@ -660,5 +650,4 @@
       IF (rh(i,k).GT.85.) RH_num(i,k)=10
       IF (rh(i,k).GT.90.) RH_num(i,k)=11
-      
       DELTA(i,k)=(rh(i,k)-RH_tab(RH_num(i,k)))*fact_RH(RH_num(i,k))
     ENDDO
@@ -718,5 +707,4 @@
     used_aer(id)=.TRUE.
 
-     
     IF (soluble) THEN
 
@@ -739,8 +727,10 @@
 !CDIR ON_ADB(C1_ASSSM_b2)
 !CDIR ON_ADB(C2_ASSSM_b2)
+
               DO i=1, KLON
+
                 H=rh(i,k)/100
-                tmp_var=mass_temp(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
-                tmp_var_pi=mass_temp_pi(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
+                tmp_var=m_allaer(i,k,spsol)/1.e6*zdh(i,k)*fac
+                tmp_var_pi=m_allaer_pi(i,k,spsol)/1.e6*zdh(i,k)*fac
 
                 ! band 1
@@ -784,8 +774,10 @@
 !CDIR ON_ADB(C1_CSSSM_b2)
 !CDIR ON_ADB(C2_CSSSM_b2)
+
               DO i=1, KLON
+
                 H=rh(i,k)/100
-                tmp_var=mass_temp(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
-                tmp_var_pi=mass_temp_pi(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
+                tmp_var=m_allaer(i,k,spsol)/1.e6*zdh(i,k)*fac
+                tmp_var_pi=m_allaer_pi(i,k,spsol)/1.e6*zdh(i,k)*fac
                 ! band 1
                 tau_ae2b_int=A1_CSSSM_b1(k)+A2_CSSSM_b1(k)*H+A3_CSSSM_b1(k)/(H-1.05)
@@ -828,8 +820,10 @@
 !CDIR ON_ADB(C1_SSSSM_b2)
 !CDIR ON_ADB(C2_SSSSM_b2)
+
               DO i=1, KLON
+
                 H=rh(i,k)/100
-                tmp_var=mass_temp(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
-                tmp_var_pi=mass_temp_pi(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
+                tmp_var=m_allaer(i,k,spsol)/1.e6*zdh(i,k)*fac
+                tmp_var_pi=m_allaer_pi(i,k,spsol)/1.e6*zdh(i,k)*fac
 
                 ! band 1 
@@ -864,6 +858,6 @@
           DO k=1, KLEV
             DO i=1, KLON
-              tmp_var=mass_temp(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
-              tmp_var_pi=mass_temp_pi(i,k,spsol)*1000.*zdp1(i,k)*delt*fac
+              tmp_var=m_allaer(i,k,spsol)/1.e6*zdh(i,k)*fac
+              tmp_var_pi=m_allaer_pi(i,k,spsol)/1.e6*zdh(i,k)*fac
 !CDIR UNROLL=nbands
               DO inu=1,nbands
@@ -899,6 +893,6 @@
         DO k=1, KLEV
           DO i=1, KLON
-            tmp_var=mass_temp(i,k,naero_soluble+ spinsol)*1000.*zdp1(i,k)*delt*fac
-            tmp_var_pi=mass_temp_pi(i,k,naero_soluble+spinsol)*1000.*zdp1(i,k)*delt*fac
+            tmp_var=m_allaer(i,k,naero_soluble+spinsol)/1.e6*zdh(i,k)*fac
+            tmp_var_pi=m_allaer_pi(i,k,naero_soluble+spinsol)/1.e6*zdh(i,k)*fac
 !CDIR UNROLL=nbands
             DO inu=1,nbands
@@ -931,6 +925,10 @@
 
   DO inu=1, nbands
-    DO mrfspecies=1,naero_grp
+
+    !!DO mrfspecies=1,naero_grp
+    DO mrfspecies=2,3    !--only deal with total and natural aerosols
+
       IF (mrfspecies .EQ. 2) THEN             ! = total aerosol AER	 
+
         DO k=1, KLEV
           DO i=1, KLON
@@ -1026,4 +1024,5 @@
                    
       ELSEIF (mrfspecies .EQ. 4) THEN             ! = BC
+
         DO k=1, KLEV
           DO i=1, KLON
@@ -1128,5 +1127,5 @@
   ENDDO
 
-  inu=1         ! visible wavaband
+  inu=1         ! visible waveband
   mrfspecies=2  ! total aerosol AER	 
   DO i=1, KLON
Index: LMDZ5/branches/testing/libf/phylmd/aeropt_5wv.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/aeropt_5wv.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/aeropt_5wv.F90	(revision 2641)
@@ -13,5 +13,4 @@
   USE phys_local_var_mod, only: od550aer,od865aer,ec550aer,od550lt1aer
   USE pres2lev_mod
-
 
   !
@@ -66,9 +65,7 @@
   ! Output arguments:
   !
-  REAL, DIMENSION(klon), INTENT(out)          :: ai      ! POLDER aerosol index 
+  REAL, DIMENSION(klon), INTENT(out)          :: ai      ! POLDER aerosol index
   REAL, DIMENSION(klon,nwave,naero_tot), INTENT(out)      :: tausum
   REAL, DIMENSION(klon,klev,nwave,naero_tot), INTENT(out) :: tau
-
-
   !
   ! Local
@@ -134,15 +131,13 @@
   REAL :: cg_ae5wv_int  ! Intermediate asymmetry parameter aerosol
   REAL, PARAMETER :: RH_MAX=95.
-  REAL :: taue670(KLON)       ! epaisseur optique aerosol absorption 550 nm
-  REAL :: taue865(KLON)       ! epaisseur optique aerosol extinction 865 nm
+  REAL :: taue670(klon)       ! epaisseur optique aerosol absorption 550 nm
+  REAL :: taue865(klon)       ! epaisseur optique aerosol extinction 865 nm
   REAL :: fac
-  REAL :: zdp1(klon,klev) 
-  REAL, PARAMETER ::  gravit = 9.80616    ! m2/s
   INTEGER, ALLOCATABLE, DIMENSION(:)  :: aerosol_name
   INTEGER :: nb_aer
   
-  REAL :: tau3d(KLON,KLEV), piz3d(KLON,KLEV), cg3d(KLON,KLEV)
-  REAL :: abs3d(KLON,KLEV)     ! epaisseur optique d'absorption
-  REAL :: dh(KLON,KLEV)
+  REAL :: tau3d(klon,klev), piz3d(klon,klev), cg3d(klon,klev)
+  REAL :: abs3d(klon,klev)     ! epaisseur optique d'absorption
+  REAL :: dh(klon,klev)
   
   REAL :: alpha_aers_5wv(nbre_RH,las,naero_soluble)   ! ext. coeff. Soluble comp. units *** m2/g 
@@ -155,12 +150,7 @@
    !  1- BC soluble; 2- POM soluble; 3- SO4 acc.; 4- SO4 coarse; 5 seasalt super-C; 6 seasalt coarse; 7 seasalt acc.
   REAL :: piz_aeri_5wv(las,naero_insoluble)           ! Insoluble comp. 1- Dust: 2- BC; 3- POM
-
-  REAL, DIMENSION(klon,klev,naero_tot) :: mass_temp
-  
   !
   ! Proprietes optiques
   !
-  REAL :: radry = 287.054
-  REAL :: tau_tmp                     ! dry air mass constant
   REAL :: fact_RH(nbre_RH)
   LOGICAL :: used_tau(naero_spc)
@@ -303,8 +293,4 @@
 !*********************************************************************
 !
-!
-! 
-! 
-!  
 ! 
 ! From here on we look at the optical parameters at 5 wavelengths:  
@@ -478,5 +464,4 @@
       0.737,0.750,0.765,0.775,0.787,0.803/
  !
-
   DATA cg_aeri_5wv/&
      ! dust insoluble
@@ -616,20 +601,15 @@
   END IF ! firstcall
 
-
   ! Initialisations
-  ai(:) = 0.
-  tausum(:,:,:) = 0.
-
+  tau(:,:,:,:) =0.
+  tausum(:,:,:)= 0.
+  ai(:)=0.0
 
   DO k=1, klev
     DO i=1, klon
-      zrho=pplay(i,k)/t_seri(i,k)/RD                  ! kg/m3
-      dh(i,k)=pdel(i,k)/(gravit*zrho)
-      mass_temp(i,k,:) = m_allaer(i,k,:) / zrho / 1.e+9
-      zdp1(i,k)=pdel(i,k)/(gravit*delt)     ! air mass auxiliary  variable --> zdp1 [kg/(m^2 *s)]
-
+      zrho=pplay(i,k)/t_seri(i,k)/RD     ! kg/m3
+      dh(i,k)=pdel(i,k)/(RG*zrho)    ! m
     ENDDO
   ENDDO
-
 
   IF (flag_aerosol .EQ. 1) THEN 
@@ -680,22 +660,18 @@
   !      compute optical_thickness_at_gridpoint_per_species
   
-
   !
   ! Calculations that need to be done since we are not in the subroutines INCA
   !      
 
-!CDIR ON_ADB(RH_tab)
-!CDIR ON_ADB(fact_RH)
-!CDIR NOVECTOR
   DO n=1,nbre_RH-1
     fact_RH(n)=1./(RH_tab(n+1)-RH_tab(n))
   ENDDO
    
-  DO k=1, KLEV
-!CDIR ON_ADB(RH_tab)
-!CDIR ON_ADB(fact_RH)
-    DO i=1, KLON
+  DO k=1, klev
+    DO i=1, klon
       rh(i,k)=MIN(RHcl(i,k)*100.,RH_MAX)
       RH_num(i,k) = INT( rh(i,k)/10. + 1.)
+!--test olivier pour pas de reindicage
+!      RH_num(i,k) =1
       IF (rh(i,k).GT.85.) RH_num(i,k)=10
       IF (rh(i,k).GT.90.) RH_num(i,k)=11
@@ -704,5 +680,4 @@
   ENDDO
 
-!CDIR SHORTLOOP  
   used_tau(:)=.FALSE.
     
@@ -765,17 +740,16 @@
     DO la=1,las
 
+    !--only 550 and 865 nm are used
+    IF (la.NE.la550.AND.la.NE.la865) CYCLE
+
       IF (soluble) THEN
 
-        IF((la.EQ.2).AND.(spss.NE.0)) THEN !la=2 corresponds to 550 nm
+        IF ((la.EQ.2).AND.(spss.NE.0)) THEN !la=2 corresponds to 550 nm
           IF (spss.EQ.1) THEN !accumulation mode
-            DO k=1, KLEV
-!CDIR ON_ADB(A1_ASSSM)
-!CDIR ON_ADB(A2_ASSSM)
-!CDIR ON_ADB(A3_ASSSM)
-              DO i=1, KLON
-                H=rh(i,k)/100
+            DO k=1, klev
+              DO i=1, klon
+                H=rh(i,k)/100.
                 tau_ae5wv_int=A1_ASSSM(k)+A2_ASSSM(k)*H+A3_ASSSM(k)/(H-1.05)
-                tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)   &
-                                   *tau_ae5wv_int*delt*fac
+                tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*dh(i,k)*tau_ae5wv_int*fac
                 tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
               ENDDO
@@ -784,28 +758,9 @@
   
           IF (spss.EQ.2) THEN !coarse mode
-            DO k=1, KLEV
-!CDIR ON_ADB(A1_CSSSM)
-!CDIR ON_ADB(A2_CSSSM)
-!CDIR ON_ADB(A3_CSSSM)
-              DO i=1, KLON
-                H=rh(i,k)/100
+            DO k=1, klev
+              DO i=1, klon
+                H=rh(i,k)/100.
                 tau_ae5wv_int=A1_CSSSM(k)+A2_CSSSM(k)*H+A3_CSSSM(k)/(H-1.05)
-                tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)  &
-                                   *tau_ae5wv_int*delt*fac
-                tausum(i,la,aerindex) = tausum(i,la,aerindex)+tau(i,k,la,aerindex)
-              ENDDO
-            ENDDO
-          ENDIF
-
-          IF (spss.EQ.3) THEN !super coarse mode
-            DO k=1, KLEV
-!CDIR ON_ADB(A1_SSSSM)
-!CDIR ON_ADB(A2_SSSSM)
-!CDIR ON_ADB(A3_SSSSM)
-              DO i=1, KLON
-                H=rh(i,k)/100
-                tau_ae5wv_int=A1_SSSSM(k)+A2_SSSSM(k)*H+A3_SSSSM(k)/(H-1.05)
-                tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)  &
-                                   *tau_ae5wv_int*delt*fac
+                tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*dh(i,k)*tau_ae5wv_int*fac
                 tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
               ENDDO
@@ -813,14 +768,22 @@
           ENDIF
 
+          IF (spss.EQ.3) THEN !super coarse mode
+            DO k=1, klev
+              DO i=1, klon
+                H=rh(i,k)/100.
+                tau_ae5wv_int=A1_SSSSM(k)+A2_SSSSM(k)*H+A3_SSSSM(k)/(H-1.05)
+                tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*dh(i,k)*tau_ae5wv_int*fac
+                tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
+              ENDDO
+            ENDDO
+          ENDIF
+
         ELSE
-          DO k=1, KLEV
-!CDIR ON_ADB(alpha_aers_5wv)
-            DO i=1, KLON
+          DO k=1, klev
+            DO i=1, klon
               tau_ae5wv_int = alpha_aers_5wv(RH_num(i,k),la,spsol)+DELTA(i,k)* &
                              (alpha_aers_5wv(RH_num(i,k)+1,la,spsol) - & 
                               alpha_aers_5wv(RH_num(i,k),la,spsol))
-
-              tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)   &
-                                 *tau_ae5wv_int*delt*fac
+              tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*dh(i,k)*tau_ae5wv_int*fac
               tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
             ENDDO
@@ -829,14 +792,15 @@
 
       ELSE                                                  ! For insoluble aerosol
-        DO k=1, KLEV
-!CDIR ON_ADB(alpha_aeri_5wv)
-          DO i=1, KLON
+
+        DO k=1, klev
+          DO i=1, klon
             tau_ae5wv_int = alpha_aeri_5wv(la,spinsol)
-            tau(i,k,la,aerindex) = mass_temp(i,k,aerindex)*1000.*zdp1(i,k)* &
-                                                tau_ae5wv_int*delt*fac
-            tausum(i,la,aerindex)= tausum(i,la,aerindex)+tau(i,k,la,aerindex)
+            tau(i,k,la,aerindex) = m_allaer(i,k,aerindex)/1.e6*dh(i,k)*tau_ae5wv_int*fac
+            tausum(i,la,aerindex)=tausum(i,la,aerindex)+tau(i,k,la,aerindex)
           ENDDO
         ENDDO
+
       ENDIF
+
     ENDDO   ! boucle sur les longueurs d'onde
   ENDDO     ! Boucle  sur les masses de traceurs
@@ -845,40 +809,16 @@
     IF (.NOT.used_tau(m)) tau(:,:,:,m)=0.
   ENDDO  
-!
-!
-!  taue670(:) = SUM(tausum(:,la670,:),dim=2) 
-!  taue865(:) = SUM(tausum(:,la865,:),dim=2) 
-!
-!  DO i=1, klon
-!    ai(i)=-LOG(MAX(taue670(i),0.0001)/ &
-!       MAX(taue865(i),0.0001))/LOG(670./865.)
-!  ENDDO
-
-  DO i=1, klon
-     od550aer(i)=0.
-     DO m=1,naero_spc
-        od550aer(i)=od550aer(i)+tausum(i,2,m)
-     ENDDO
-  ENDDO
-
-  DO i=1, klon
-     od865aer(i)=0.
-     DO m=1,naero_spc
-        od865aer(i)=od865aer(i)+tausum(i,5,m)
-     ENDDO
-  ENDDO
-
-  DO i=1, klon
-     DO k=1, KLEV
-        ec550aer(i,k)=0.
-        DO m=1,naero_spc
-           ec550aer(i,k)=ec550aer(i,k)+tau(i,k,2,m)/dh(i,k)
-        ENDDO
-     ENDDO
-  ENDDO
+
+!--AOD calculations for diagnostics
+  od550aer(:)=SUM(tausum(:,la550,:),dim=2)
+  od865aer(:)=SUM(tausum(:,la865,:),dim=2)
+
+!--extinction coefficient for diagnostic
+  ec550aer(:,:)=SUM(tau(:,:,la550,:),dim=3)/dh(:,:)
   
-   od550lt1aer(:)=tausum(:,2,id_ASSO4M_phy)+tausum(:,2,id_ASBCM_phy)+tausum(:,2,id_AIBCM_phy)+  &
-                  tausum(:,2,id_ASPOMM_phy)+tausum(:,2,id_AIPOMM_phy)+tausum(:,2,id_ASSSM_phy)+ &
-                  0.03*tausum(:,2,id_CSSSM_phy)+0.4*tausum(:,2,id_CIDUSTM_phy)
+!--acc mode AOD calculation for diagnostic
+  od550lt1aer(:)=tausum(:,la550,id_ASSO4M_phy)+tausum(:,la550,id_ASBCM_phy)+tausum(:,la550,id_AIBCM_phy)+  &
+                 tausum(:,la550,id_ASPOMM_phy)+tausum(:,la550,id_AIPOMM_phy)+tausum(:,la550,id_ASSSM_phy)+ &
+                 0.03*tausum(:,la550,id_CSSSM_phy)+0.4*tausum(:,la550,id_CIDUSTM_phy)
 
   DEALLOCATE(aerosol_name) 
Index: LMDZ5/branches/testing/libf/phylmd/calwake.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/calwake.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/calwake.F90	(revision 2641)
@@ -2,11 +2,17 @@
 ! $Id$
 
-SUBROUTINE calwake(paprs, pplay, dtime, t, q, omgb, dt_dwn, dq_dwn, m_dwn, &
-    m_up, dt_a, dq_a, sigd, wdt_pbl, wdq_pbl, udt_pbl, udq_pbl, wake_deltat, &
-    wake_deltaq, wake_dth, wake_h, wake_s, wake_dens, wake_pe, wake_fip, &
-    wake_gfl, dt_wake, dq_wake, wake_k, undi_t, undi_q, wake_omgbdth, &
-    wake_dp_omgb, wake_dtke, wake_dqke, wake_dtpbl, wake_dqpbl, wake_omg, &
-    wake_dp_deltomg, wake_spread, wake_cstar, wake_d_deltat_gw, wake_ddeltat, &
-    wake_ddeltaq)
+SUBROUTINE calwake(iflag_wake_tend, paprs, pplay, dtime, &
+    t, q, omgb, &
+    dt_dwn, dq_dwn, m_dwn, m_up, dt_a, dq_a, &
+    sigd, &
+    wake_deltat, wake_deltaq, wake_s, wake_dens, &
+    wake_dth, wake_h, &
+    wake_pe, wake_fip, wake_gfl, &
+    dt_wake, dq_wake, wake_k, t_x, q_x, wake_omgbdth, &
+    wake_dp_omgb, &
+    wake_dtke, wake_dqke, &
+    wake_omg, wake_dp_deltomg, &
+    wake_spread, wake_cstar, wake_d_deltat_gw, &
+    wake_ddeltat, wake_ddeltaq, wake_ds, wake_ddens)
   ! **************************************************************
   ! *
@@ -26,57 +32,67 @@
   ! Arguments
   ! ----------
-
-  INTEGER i, l, ktopw(klon)
-  REAL dtime
-
-  REAL paprs(klon, klev+1), pplay(klon, klev)
-  REAL t(klon, klev), q(klon, klev), omgb(klon, klev)
-  REAL dt_dwn(klon, klev), dq_dwn(klon, klev), m_dwn(klon, klev)
-  REAL m_up(klon, klev)
-  REAL dt_a(klon, klev), dq_a(klon, klev)
-  REAL wdt_pbl(klon, klev), wdq_pbl(klon, klev)
-  REAL udt_pbl(klon, klev), udq_pbl(klon, klev)
-  REAL wake_deltat(klon, klev), wake_deltaq(klon, klev)
-  REAL dt_wake(klon, klev), dq_wake(klon, klev)
-  REAL wake_d_deltat_gw(klon, klev)
-  REAL wake_h(klon), wake_s(klon)
-  REAL wake_dth(klon, klev)
-  REAL wake_pe(klon), wake_fip(klon), wake_gfl(klon)
-  REAL undi_t(klon, klev), undi_q(klon, klev)
-  REAL wake_omgbdth(klon, klev), wake_dp_omgb(klon, klev)
-  REAL wake_dtke(klon, klev), wake_dqke(klon, klev)
-  REAL wake_dtpbl(klon, klev), wake_dqpbl(klon, klev)
-  REAL wake_omg(klon, klev), wake_dp_deltomg(klon, klev)
-  REAL wake_spread(klon, klev), wake_cstar(klon)
-  REAL wake_ddeltat(klon, klev), wake_ddeltaq(klon, klev)
-  REAL d_deltatw(klon, klev), d_deltaqw(klon, klev)
-  INTEGER wake_k(klon)
-  REAL sigd(klon)
-  REAL wake_dens(klon)
+  ! Input
+  ! ----
+  INTEGER,                       INTENT (IN)         :: iflag_wake_tend
+  REAL,                          INTENT (IN)         :: dtime
+  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: pplay
+  REAL, DIMENSION(klon, klev+1), INTENT (IN)         :: paprs
+  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: t, q, omgb
+  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: dt_dwn, dq_dwn
+  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: m_up, m_dwn
+  REAL, DIMENSION(klon, klev),   INTENT (IN)         :: dt_a, dq_a
+  REAL, DIMENSION(klon),         INTENT (IN)         :: sigd
+  ! Input/Output
+  ! ------------
+  REAL, DIMENSION(klon, klev),   INTENT (INOUT)      :: wake_deltat, wake_deltaq
+  REAL, DIMENSION(klon),         INTENT (INOUT)      :: wake_s
+  REAL, DIMENSION(klon),         INTENT (INOUT)      :: wake_dens
+  ! Output
+  ! ------
+  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: dt_wake, dq_wake
+  INTEGER, DIMENSION(klon),      INTENT (OUT)        :: wake_k
+  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_d_deltat_gw
+  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_h
+  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_dth
+  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_pe, wake_fip, wake_gfl
+  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: t_x, q_x
+  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_omgbdth, wake_dp_omgb
+  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_dtke, wake_dqke
+  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_omg, wake_dp_deltomg
+  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_spread
+  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_cstar
+  REAL, DIMENSION(klon, klev),   INTENT (OUT)        :: wake_ddeltat, wake_ddeltaq
+  REAL, DIMENSION(klon),         INTENT (OUT)        :: wake_ds, wake_ddens
+
 
   ! Variable internes
   ! -----------------
-
-  REAL aire
-  REAL p(klon, klev), ph(klon, klev+1), pi(klon, klev)
-  REAL te(klon, klev), qe(klon, klev), omgbe(klon, klev+1)
-  REAL dtdwn(klon, klev), dqdwn(klon, klev)
-  REAL dta(klon, klev), dqa(klon, klev)
-  REAL wdtpbl(klon, klev), wdqpbl(klon, klev)
-  REAL udtpbl(klon, klev), udqpbl(klon, klev)
-  REAL amdwn(klon, klev), amup(klon, klev)
-  REAL dtw(klon, klev), dqw(klon, klev), dth(klon, klev)
-  REAL d_deltat_gw(klon, klev)
-  REAL dtls(klon, klev), dqls(klon, klev)
-  REAL tu(klon, klev), qu(klon, klev)
-  REAL hw(klon), sigmaw(klon), wape(klon), fip(klon), gfl(klon)
-  REAL omgbdth(klon, klev+1), dp_omgb(klon, klev)
-  REAL dtke(klon, klev), dqke(klon, klev)
-  REAL dtpbl(klon, klev), dqpbl(klon, klev)
-  REAL omg(klon, klev+1), dp_deltomg(klon, klev), spread(klon, klev)
-  REAL cstar(klon)
-  REAL sigd0(klon), wdens(klon)
-
-  REAL rdcp
+  INTEGER                                            :: i, l
+  REAL                                               :: aire
+  REAL, DIMENSION(klon, klev)                        :: p,  pi
+  REAL, DIMENSION(klon, klev+1)                      ::  ph, omgbe
+  REAL, DIMENSION(klon, klev)                        :: te, qe
+  REAL, DIMENSION(klon, klev)                        :: dtdwn, dqdwn
+  REAL, DIMENSION(klon, klev)                        :: dta, dqa
+  REAL, DIMENSION(klon, klev)                        :: amdwn, amup
+  REAL, DIMENSION(klon, klev)                        :: dtw, dqw, dth
+  REAL, DIMENSION(klon, klev)                        :: dtls, dqls
+  REAL, DIMENSION(klon, klev)                        :: tx, qx
+  REAL, DIMENSION(klon)                              :: hw, wape, fip, gfl
+  REAL, DIMENSION(klon)                              :: sigmaw, wdens
+  REAL, DIMENSION(klon, klev+1)                      :: omgbdth
+  REAL, DIMENSION(klon, klev)                        :: dp_omgb
+  REAL, DIMENSION(klon, klev)                        :: dtke, dqke
+  REAL, DIMENSION(klon, klev+1)                      :: omg
+  REAL, DIMENSION(klon, klev)                        :: dp_deltomg, spread
+  REAL, DIMENSION(klon)                              :: cstar
+  REAL, DIMENSION(klon)                              :: sigd0
+  INTEGER, DIMENSION(klon)                           :: ktopw
+  REAL, DIMENSION(klon, klev)                        :: d_deltat_gw
+  REAL, DIMENSION(klon, klev)                        :: d_deltatw, d_deltaqw
+  REAL, DIMENSION(klon)                              :: d_sigmaw, d_wdens
+
+  REAL                                               :: rdcp
+
 
   ! print *, '-> calwake, wake_s ', wake_s(1)
@@ -104,8 +120,4 @@
       dta(i, l) = dt_a(i, l)
       dqa(i, l) = dq_a(i, l)
-      wdtpbl(i, l) = wdt_pbl(i, l)
-      wdqpbl(i, l) = wdq_pbl(i, l)
-      udtpbl(i, l) = udt_pbl(i, l)
-      udqpbl(i, l) = udq_pbl(i, l)
     END DO
   END DO
@@ -125,4 +137,9 @@
   END DO
 
+  DO i = 1, klon
+    hw(i) = wake_h(i)
+  END DO
+!
+!    Make a copy of state variables
   DO l = 1, klev
     DO i = 1, klon
@@ -132,14 +149,10 @@
   END DO
 
-  DO l = 1, klev
-    DO i = 1, klon
-      dtls(i, l) = dt_wake(i, l)
-      dqls(i, l) = dq_wake(i, l)
-    END DO
-  END DO
-
-  DO i = 1, klon
-    hw(i) = wake_h(i)
+  DO i = 1, klon
     sigmaw(i) = wake_s(i)
+  END DO
+
+  DO i = 1, klon
+    wdens(i) = wake_dens(i)
   END DO
 
@@ -166,15 +179,19 @@
   END DO
 
-  CALL wake(p, ph, pi, dtime, sigd0, te, qe, omgbe, dtdwn, dqdwn, amdwn, &
-    amup, dta, dqa, wdtpbl, wdqpbl, udtpbl, udqpbl, dtw, dqw, dth, hw, &
-    sigmaw, wape, fip, gfl, dtls, dqls, ktopw, omgbdth, dp_omgb, wdens, tu, &
-    qu, dtke, dqke, dtpbl, dqpbl, omg, dp_deltomg, spread, cstar, &
-    d_deltat_gw, d_deltatw, d_deltaqw)
-
+  CALL wake(p, ph, pi, dtime, &
+    te, qe, omgbe, &
+    dtdwn, dqdwn, amdwn, amup, dta, dqa, &
+    sigd0, &
+    dtw, dqw, sigmaw, wdens, &                                   ! state variables
+    dth, hw, wape, fip, gfl, &
+    dtls, dqls, ktopw, omgbdth, dp_omgb, tx, qx, &
+    dtke, dqke, omg, dp_deltomg, spread, cstar, &
+    d_deltat_gw, &
+    d_deltatw, d_deltaqw, d_sigmaw, d_wdens)                     ! tendencies
+
+!
   DO l = 1, klev
     DO i = 1, klon
       IF (ktopw(i)>0) THEN
-        wake_deltat(i, l) = dtw(i, l)
-        wake_deltaq(i, l) = dqw(i, l)
         wake_d_deltat_gw(i, l) = d_deltat_gw(i, l)
         wake_omgbdth(i, l) = omgbdth(i, l)
@@ -182,19 +199,13 @@
         wake_dtke(i, l) = dtke(i, l)
         wake_dqke(i, l) = dqke(i, l)
-        wake_dtpbl(i, l) = dtpbl(i, l)
-        wake_dqpbl(i, l) = dqpbl(i, l)
         wake_omg(i, l) = omg(i, l)
         wake_dp_deltomg(i, l) = dp_deltomg(i, l)
         wake_spread(i, l) = spread(i, l)
         wake_dth(i, l) = dth(i, l)
-        dt_wake(i, l) = dtls(i, l)
-        dq_wake(i, l) = dqls(i, l)
-        undi_t(i, l) = tu(i, l)
-        undi_q(i, l) = qu(i, l)
-        wake_ddeltat(i, l) = d_deltatw(i, l)
-        wake_ddeltaq(i, l) = d_deltaqw(i, l)
+        dt_wake(i, l) = dtls(i, l)*dtime         ! derivative -> tendency
+        dq_wake(i, l) = dqls(i, l)*dtime         ! derivative -> tendency
+        t_x(i, l) = tx(i, l)
+        q_x(i, l) = qx(i, l)
       ELSE
-        wake_deltat(i, l) = 0.
-        wake_deltaq(i, l) = 0.
         wake_d_deltat_gw(i, l) = 0.
         wake_omgbdth(i, l) = 0.
@@ -202,6 +213,4 @@
         wake_dtke(i, l) = 0.
         wake_dqke(i, l) = 0.
-        wake_dtpbl(i, l) = 0.
-        wake_dqpbl(i, l) = 0.
         wake_omg(i, l) = 0.
         wake_dp_deltomg(i, l) = 0.
@@ -210,8 +219,6 @@
         dt_wake(i, l) = 0.
         dq_wake(i, l) = 0.
-        undi_t(i, l) = te(i, l)
-        undi_q(i, l) = qe(i, l)
-        wake_ddeltat(i, l) = 0.
-        wake_ddeltaq(i, l) = 0.
+        t_x(i, l) = te(i, l)
+        q_x(i, l) = qe(i, l)
       END IF
     END DO
@@ -220,5 +227,4 @@
   DO i = 1, klon
     wake_h(i) = hw(i)
-    wake_s(i) = sigmaw(i)
     wake_pe(i) = wape(i)
     wake_fip(i) = fip(i)
@@ -226,7 +232,50 @@
     wake_k(i) = ktopw(i)
     wake_cstar(i) = cstar(i)
-    wake_dens(i) = wdens(i)
-  END DO
+  END DO
+
+!  Tendencies of state variables
+  DO l = 1, klev
+    DO i = 1, klon
+      IF (ktopw(i)>0) THEN
+        wake_ddeltat(i, l) = d_deltatw(i, l)*dtime
+        wake_ddeltaq(i, l) = d_deltaqw(i, l)*dtime
+      ELSE
+        wake_ddeltat(i, l) = -wake_deltat(i, l)
+        wake_ddeltaq(i, l) = -wake_deltaq(i, l)
+      END IF
+    END DO
+  END DO
+  DO i = 1, klon
+    IF (ktopw(i)>0) THEN
+      wake_ds(i) = d_sigmaw(i)*dtime
+      wake_ddens(i) = d_wdens(i)*dtime
+    ELSE
+      wake_ds(i)   = -wake_s(i)
+      wake_ddens(i)= -wake_dens(i)
+    END IF
+  END DO
+
+!jyg<  
+  IF (iflag_wake_tend .EQ. 0) THEN
+!  Update State variables
+    DO l = 1, klev
+      DO i = 1, klon
+        IF (ktopw(i)>0) THEN
+          wake_deltat(i, l) = dtw(i, l)
+          wake_deltaq(i, l) = dqw(i, l)
+        ELSE
+          wake_deltat(i, l) = 0.
+          wake_deltaq(i, l) = 0.
+        END IF
+      END DO
+    END DO
+    DO i = 1, klon
+      wake_s(i) = sigmaw(i)
+      wake_dens(i) = wdens(i)
+    END DO
+  ENDIF
+!>jyg
 
   RETURN
 END SUBROUTINE calwake
+
Index: LMDZ5/branches/testing/libf/phylmd/cmp_seri_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cmp_seri_mod.F90	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/cmp_seri_mod.F90	(revision 2641)
@@ -0,0 +1,156 @@
+!
+! $Id:  ??? $
+!
+MODULE cmp_seri_mod
+  !======================================================================
+  ! to check if the x_seri vaariables have changed
+  !
+  !======================================================================
+
+  REAL,SAVE,ALLOCATABLE ::  u_prev(:,:), v_prev(:,:), ql_prev(:,:), &
+       qs_prev(:,:), q_prev(:,:), t_prev(:,:)
+  !$OMP THREADPRIVATE(u_prev, v_prev, ql_prev, qs_prev, q_prev, t_prev)
+
+CONTAINS
+
+  SUBROUTINE init_cmp_seri
+    !======================================================================
+    !
+    !======================================================================
+
+    !======================================================================
+    ! Declarations
+    !======================================================================
+    USE dimphy, ONLY: klon, klev
+    USE phys_local_var_mod, ONLY: u_seri, v_seri, ql_seri, qs_seri, q_seri, &
+         t_seri
+    !
+    IMPLICIT none
+    ! Local :
+    !--------
+    logical, save :: first=.true.
+    !$OMP THREADPRIVATE(first)
+
+    !
+    !======================================================================
+    !
+    if (first) then
+       ALLOCATE(u_prev(klon,klev))
+       ALLOCATE(v_prev(klon,klev))
+       ALLOCATE(ql_prev(klon,klev))
+       ALLOCATE(qs_prev(klon,klev))
+       ALLOCATE(q_prev(klon,klev))
+       ALLOCATE(t_prev(klon,klev))
+       first=.false.
+    endif
+    ! store current values of x_seri variables
+    u_prev(:,:) =u_seri(:,:)
+    v_prev(:,:) =v_seri(:,:)
+    ql_prev(:,:)=ql_seri(:,:)
+    qs_prev(:,:)=qs_seri(:,:)
+    t_prev(:,:) =t_seri(:,:)
+    q_prev(:,:) =q_seri(:,:)
+
+  END SUBROUTINE init_cmp_seri
+
+  !======================================================================
+  !
+  !======================================================================
+  SUBROUTINE cmp_seri(iflag,text)
+    !
+    USE dimphy, ONLY: klon, klev
+    USE phys_local_var_mod, ONLY: u_seri, v_seri, ql_seri, qs_seri, q_seri, &
+         t_seri
+    USE print_control_mod, ONLY: prt_level
+    IMPLICIT none
+    ! Arguments :
+    !------------
+    integer iflag
+    CHARACTER*(*) text
+    ! Local :
+    !--------
+    integer i, k
+    real du_seri(klon,klev), dv_seri(klon,klev), dql_seri(klon,klev), &
+         dqs_seri(klon,klev), dq_seri(klon,klev), dt_seri(klon,klev)
+    logical t_differ, u_differ, v_differ, ql_differ, qs_differ, q_differ
+    logical any_differ
+    !
+    any_differ = .false.
+    !
+    dt_seri(:,:)=t_seri(:,:)-t_prev(:,:)
+    IF (any(t_seri/=t_prev)) then
+       if ( .not. any_differ ) write (*,*) "In cmp_seri, after ",text
+       write (*,*) '*** t_seri has changed',minval(dt_seri),maxval(dt_seri)
+       t_differ=.true.
+       any_differ = .true.
+    ELSE
+       t_differ=.false.
+    END IF
+    !
+    dq_seri(:,:)=q_seri(:,:)-q_prev(:,:)
+    IF (any(q_seri/=q_prev)) then
+       if ( .not. any_differ ) write (*,*) "In cmp_seri, after ",text
+       write (*,*) '*** q_seri has changed',minval(dq_seri),maxval(dq_seri)
+       q_differ=.true.
+       any_differ = .true.
+    ELSE
+       q_differ=.false.
+    END IF
+    !
+    dql_seri(:,:)=ql_seri(:,:)-ql_prev(:,:)
+    IF (any(ql_seri/=ql_prev)) then
+       if ( .not. any_differ ) write (*,*) "In cmp_seri, after ",text
+       write (*,*) '*** ql_seri has changed',minval(dql_seri),maxval(dql_seri)
+       ql_differ=.true.
+       any_differ = .true.
+    ELSE
+       ql_differ=.false.
+    END IF
+    !
+    dqs_seri(:,:)=qs_seri(:,:)-qs_prev(:,:)
+    IF (any(qs_seri/=qs_prev)) then
+       if ( .not. any_differ ) write (*,*) "In cmp_seri, after ",text
+       write (*,*) '*** qs_seri has changed',minval(dqs_seri),maxval(dqs_seri)
+       qs_differ=.true.
+       any_differ = .true.
+    ELSE
+       qs_differ=.false.
+    END IF
+    !
+    du_seri(:,:)=u_seri(:,:)-u_prev(:,:)
+    IF (any(u_seri/=u_prev)) then
+       if ( .not. any_differ ) write (*,*) "In cmp_seri, after ",text
+       write (*,*) '*** u_seri has changed',minval(du_seri),maxval(du_seri)
+       u_differ=.true.
+       any_differ = .true.
+    ELSE
+       u_differ=.false.
+    END IF
+    !
+    dv_seri(:,:)=v_seri(:,:)-v_prev(:,:)
+    IF (any(v_seri/=v_prev)) then
+       if ( .not. any_differ ) write (*,*) "In cmp_seri, after ",text
+       write (*,*) '*** v_seri has changed',minval(dv_seri),maxval(dv_seri)
+       v_differ=.true.
+       any_differ = .true.
+    ELSE
+       v_differ=.false.
+    END IF
+    !
+    if (any_differ) then
+       IF (iflag >= 2 .and. prt_level >= 5) then
+          i=1
+          DO k = 1, klev
+             write(*,'(i3,6e14.6)')k, t_seri(i,k)-t_prev(i,k), u_seri(i,k)-u_prev(i,k), &
+                  v_seri(i,k)-v_prev(i,k), ql_seri(i,k)-ql_prev(i,k),&
+                  qs_seri(i,k)-qs_prev(i,k), q_seri(i,k)-q_prev(i,k)
+          ENDDO
+       END IF
+    else
+       write (*,*) 'No change for any xxx_seri after ',text
+    end if
+
+  END SUBROUTINE cmp_seri
+
+END MODULE cmp_seri_mod
+
